// XAPP132 
//  
// DLL Board Clock Mirror for Virtex chips Example
// 
// Requires external connection of CLK0_ext to CLKFB on 
// the board.
//

module dll_mirror_2 (CLKIN, CLKFB, CLK0_ext, CLK0_int, NOT_LOCKED);
input  CLKIN, CLKFB;
output CLK0_ext, CLK0_int, NOT_LOCKED;

wire CLKIN_w, CLKFB_w, CLK0_int_dll, CLK0_ext_dll;
wire LOCKED_ext_dll, NOT_LOCKED_w;
wire logic0;

assign logic0 = 1'b0;

IBUFG clkpad   (.I(CLKIN), .O(CLKIN_w));
IBUFG clkfbpad (.I(CLKFB), .O(CLKFB_w));

CLKDLL dllint (.CLKIN(CLKIN_w), .CLKFB(CLK0_int), .RST(logic0), 
               .CLK0(CLK0_int_dll), .CLK90(), .CLK180(), .CLK270(),
               .CLK2X(), .CLKDV(), .LOCKED());

CLKDLL dllext (.CLKIN(CLKIN_w), .CLKFB(CLKFB_w), .RST(logic0), 
               .CLK0(CLK0_ext_dll), .CLK90(), .CLK180(), .CLK270(),
               .CLK2X(), .CLKDV(), .LOCKED(LOCKED_ext_dll));

BUFG   clkg      (.I(CLK0_int_dll), .O(CLK0_int));
OBUF   clkextpad (.I(CLK0_ext_dll), .O(CLK0_ext));

assign NOT_LOCKED_w = ! LOCKED_ext_dll;
OBUF   notlckpad (.I(NOT_LOCKED_w), .O(NOT_LOCKED));

endmodule
